import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _get from "@babel/runtime/helpers/esm/get";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _regeneratorRuntime from "@babel/runtime/regenerator";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
// import type { ILayerConfig } from '@antv/l7-core';
import BaseLayer from "../core/BaseLayer";
import { CanvasModel } from "./models";
var CanvasLayer = /*#__PURE__*/function (_BaseLayer) {
  _inherits(CanvasLayer, _BaseLayer);
  var _super = _createSuper(CanvasLayer);
  function CanvasLayer() {
    var _this;
    _classCallCheck(this, CanvasLayer);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "type", 'CanvasLayer');
    return _this;
  }
  _createClass(CanvasLayer, [{
    key: "getDefaultConfig",
    value: function getDefaultConfig() {
      return {
        zIndex: 3,
        contextType: 'canvas2d',
        trigger: 'change'
      };
    }
  }, {
    key: "buildModels",
    value: function () {
      var _buildModels = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              this.layerModel = new CanvasModel(this);
              _context.next = 3;
              return this.initLayerModels();
            case 3:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function buildModels() {
        return _buildModels.apply(this, arguments);
      }
      return buildModels;
    }()
  }, {
    key: "getModelType",
    value: function getModelType() {
      return this.getLayerConfig().contextType || 'canvas2d';
    }
  }, {
    key: "draw",
    value: function draw(_draw) {
      this.updateLayerConfig({
        draw: _draw
      });
      this.render();
      return this;
    }
  }, {
    key: "getLayerConfig",
    value: function getLayerConfig() {
      var config = _objectSpread(_objectSpread({}, this.getDefaultConfig()), _get(_getPrototypeOf(CanvasLayer.prototype), "getLayerConfig", this).call(this));
      if (config.zIndex < 3) {
        config.zIndex = 3;
      }
      return config;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$layerModel;
      (_this$layerModel = this.layerModel) === null || _this$layerModel === void 0 || _this$layerModel.renderCanvas();
      return this;
    }
  }, {
    key: "getCanvas",
    value: function getCanvas() {
      var _this$layerModel2;
      return (_this$layerModel2 = this.layerModel) === null || _this$layerModel2 === void 0 ? void 0 : _this$layerModel2.canvas;
    }
  }, {
    key: "show",
    value: function show() {
      var canvas = this.getCanvas();
      if (canvas) {
        canvas.style.display = 'unset';
      }
      return this;
    }
  }, {
    key: "hide",
    value: function hide() {
      var canvas = this.getCanvas();
      if (canvas) {
        canvas.style.display = 'none';
      }
      return this;
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.layerModel.removeCanvas();
      _get(_getPrototypeOf(CanvasLayer.prototype), "destroy", this).call(this);
    }
  }]);
  return CanvasLayer;
}(BaseLayer);
export { CanvasLayer as default };