import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _regeneratorRuntime from "@babel/runtime/regenerator";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import BaseModel from "../../core/BaseModel";
import { CanvasUpdateType } from "../../core/interface";
import { CanvasContextTypeMap } from "./constants";
export var CanvasModel = /*#__PURE__*/function (_BaseModel) {
  _inherits(CanvasModel, _BaseModel);
  var _super = _createSuper(CanvasModel);
  function CanvasModel() {
    var _this;
    _classCallCheck(this, CanvasModel);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "canvas", null);
    _defineProperty(_assertThisInitialized(_this), "initCanvas", function () {
      var _this$mapService$getC, _this$mapService$getC2, _this$mapService, _this$mapService$getM, _this$mapService2;
      var _this$layerConfig = _this.layerConfig,
        zIndex = _this$layerConfig.zIndex,
        getContext = _this$layerConfig.getContext;
      var canvas = document.createElement('canvas');
      var modelType = _this.layer.getModelType();
      _this.canvas = canvas;
      canvas.classList.add('l7-canvas-layer');
      canvas.style.position = 'absolute';
      canvas.style.top = '0';
      canvas.style.left = '0';
      canvas.style.zIndex = String(zIndex);
      _this.resetCanvasSize();
      var container = (_this$mapService$getC = (_this$mapService$getC2 = (_this$mapService = _this.mapService).getCanvasOverlays) === null || _this$mapService$getC2 === void 0 ? void 0 : _this$mapService$getC2.call(_this$mapService)) !== null && _this$mapService$getC !== void 0 ? _this$mapService$getC : (_this$mapService$getM = (_this$mapService2 = _this.mapService).getMapCanvasContainer) === null || _this$mapService$getM === void 0 ? void 0 : _this$mapService$getM.call(_this$mapService2);
      container === null || container === void 0 || container.appendChild(canvas);
      _this.ctx = getContext ? getContext(canvas) : canvas.getContext(CanvasContextTypeMap[modelType]);
      if (!_this.ctx) {
        console.error('Failed to get rendering context for canvas');
      }
      _this.bindListeners();
    });
    _defineProperty(_assertThisInitialized(_this), "resetViewportSize", function () {
      var _this$rendererService = _this.rendererService.getViewportSize(),
        viewWidth = _this$rendererService.width,
        viewHeight = _this$rendererService.height;
      _this.viewportSize = [viewWidth, viewHeight];
    });
    _defineProperty(_assertThisInitialized(_this), "resetCanvasSize", function () {
      var canvas = _this.canvas;
      if (!canvas) {
        return;
      }
      _this.resetViewportSize();
      var _this$mapService$getS = _this.mapService.getSize(),
        _this$mapService$getS2 = _slicedToArray(_this$mapService$getS, 2),
        width = _this$mapService$getS2[0],
        height = _this$mapService$getS2[1];
      var _this$viewportSize = _slicedToArray(_this.viewportSize, 2),
        viewWidth = _this$viewportSize[0],
        viewHeight = _this$viewportSize[1];
      canvas.width = viewWidth;
      canvas.height = viewHeight;
      canvas.style.width = width + 'px';
      canvas.style.height = height + 'px';
    });
    _defineProperty(_assertThisInitialized(_this), "renderCanvas", function () {
      var _ref;
      if (!_this.canvas) {
        _this.initCanvas();
      }
      var _this$layerConfig2 = _this.layerConfig,
        draw = _this$layerConfig2.draw,
        drawingOnCanvas = _this$layerConfig2.drawingOnCanvas;
      var _this$viewportSize2 = _slicedToArray(_this.viewportSize, 2),
        width = _this$viewportSize2[0],
        height = _this$viewportSize2[1];
      var bounds = _this.mapService.getBounds();
      (_ref = draw !== null && draw !== void 0 ? draw : drawingOnCanvas) === null || _ref === void 0 || _ref({
        canvas: _this.canvas,
        ctx: _this.ctx,
        container: {
          width: width,
          height: height,
          bounds: bounds
        },
        size: [width, height],
        utils: {
          lngLatToContainer: _this.lngLatToContainer
        },
        mapService: _this.mapService
      });
    });
    _defineProperty(_assertThisInitialized(_this), "removeCanvas", function () {
      if (_this.canvas) {
        var _this$canvas$parentEl;
        (_this$canvas$parentEl = _this.canvas.parentElement) === null || _this$canvas$parentEl === void 0 || _this$canvas$parentEl.removeChild(_this.canvas);
        _this.canvas = null;
      }
      _this.unbindListeners();
    });
    _defineProperty(_assertThisInitialized(_this), "onMapResize", function () {
      requestAnimationFrame(function () {
        _this.resetCanvasSize();
        _this.renderCanvas();
      });
    });
    _defineProperty(_assertThisInitialized(_this), "lngLatToContainer", function (lngLat) {
      var _this$mapService$lngL = _this.mapService.lngLatToContainer(lngLat),
        x = _this$mapService$lngL.x,
        y = _this$mapService$lngL.y;
      return {
        x: x * window.devicePixelRatio,
        y: y * window.devicePixelRatio
      };
    });
    return _this;
  }
  _createClass(CanvasModel, [{
    key: "layerConfig",
    get: function get() {
      return this.layer.getLayerConfig();
    }
  }, {
    key: "initModels",
    value: function () {
      var _initModels = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              this.renderCanvas();
              return _context.abrupt("return", []);
            case 2:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function initModels() {
        return _initModels.apply(this, arguments);
      }
      return initModels;
    }()
  }, {
    key: "bindListeners",
    value: function bindListeners() {
      this.mapService.on('resize', this.onMapResize);
      var _this$layerConfig3 = this.layerConfig,
        trigger = _this$layerConfig3.trigger,
        update = _this$layerConfig3.update;
      if (update === CanvasUpdateType.ALWAYS || trigger === 'change') {
        this.mapService.on('mapchange', this.renderCanvas);
      } else {
        this.mapService.on('zoomstart', this.removeCanvas);
        this.mapService.on('zoomend', this.renderCanvas);
        this.mapService.on('movestart', this.removeCanvas);
        this.mapService.on('moveend', this.renderCanvas);
      }
    }
  }, {
    key: "unbindListeners",
    value: function unbindListeners() {
      this.mapService.off('resize', this.onMapResize);
      this.mapService.off('mapchange', this.renderCanvas);
      this.mapService.off('zoomstart', this.removeCanvas);
      this.mapService.off('zoomend', this.renderCanvas);
      this.mapService.off('movestart', this.removeCanvas);
      this.mapService.off('moveend', this.renderCanvas);
    }
  }, {
    key: "registerBuiltinAttributes",
    value: function registerBuiltinAttributes() {}
  }]);
  return CanvasModel;
}(BaseModel);