"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _BaseLayer2 = _interopRequireDefault(require("../core/BaseLayer"));
var _models = require("./models");
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } } // import type { ILayerConfig } from '@antv/l7-core';
var CanvasLayer = exports.default = /*#__PURE__*/function (_BaseLayer) {
  (0, _inherits2.default)(CanvasLayer, _BaseLayer);
  var _super = _createSuper(CanvasLayer);
  function CanvasLayer() {
    var _this;
    (0, _classCallCheck2.default)(this, CanvasLayer);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "type", 'CanvasLayer');
    return _this;
  }
  (0, _createClass2.default)(CanvasLayer, [{
    key: "getDefaultConfig",
    value: function getDefaultConfig() {
      return {
        zIndex: 3,
        contextType: 'canvas2d',
        trigger: 'change'
      };
    }
  }, {
    key: "buildModels",
    value: function () {
      var _buildModels = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              this.layerModel = new _models.CanvasModel(this);
              _context.next = 3;
              return this.initLayerModels();
            case 3:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function buildModels() {
        return _buildModels.apply(this, arguments);
      }
      return buildModels;
    }()
  }, {
    key: "getModelType",
    value: function getModelType() {
      return this.getLayerConfig().contextType || 'canvas2d';
    }
  }, {
    key: "draw",
    value: function draw(_draw) {
      this.updateLayerConfig({
        draw: _draw
      });
      this.render();
      return this;
    }
  }, {
    key: "getLayerConfig",
    value: function getLayerConfig() {
      var config = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, this.getDefaultConfig()), (0, _get2.default)((0, _getPrototypeOf2.default)(CanvasLayer.prototype), "getLayerConfig", this).call(this));
      if (config.zIndex < 3) {
        config.zIndex = 3;
      }
      return config;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$layerModel;
      (_this$layerModel = this.layerModel) === null || _this$layerModel === void 0 || _this$layerModel.renderCanvas();
      return this;
    }
  }, {
    key: "getCanvas",
    value: function getCanvas() {
      var _this$layerModel2;
      return (_this$layerModel2 = this.layerModel) === null || _this$layerModel2 === void 0 ? void 0 : _this$layerModel2.canvas;
    }
  }, {
    key: "show",
    value: function show() {
      var canvas = this.getCanvas();
      if (canvas) {
        canvas.style.display = 'unset';
      }
      return this;
    }
  }, {
    key: "hide",
    value: function hide() {
      var canvas = this.getCanvas();
      if (canvas) {
        canvas.style.display = 'none';
      }
      return this;
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.layerModel.removeCanvas();
      (0, _get2.default)((0, _getPrototypeOf2.default)(CanvasLayer.prototype), "destroy", this).call(this);
    }
  }]);
  return CanvasLayer;
}(_BaseLayer2.default);